routes/web.php
<?php

use App\Http\Controllers\AwardsController;
use App\Http\Controllers\PointsController;
use App\Http\Controllers\ProfileController;
use App\Http\Controllers\SendAwardsController;
use App\Http\Controllers\UsersController;
use App\Http\Controllers\VounchersController;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider and all of them will
| be assigned to the "web" middleware group. Make something great!
|
*/

Route::middleware('auth')->group(function () {

    Route::get('/', [UsersController::class, 'dashboard'])->name('dashboard');

    // USERS
    Route::middleware('admin')->prefix('usuarios')->group(function () {
        Route::name('users.')->group(function () {
            Route::get('/adicionar', [UsersController::class, 'create'])->name('create');
            Route::post('/adicionar', [UsersController::class, 'store'])->name('store');
            Route::get('/visualizando/{id}', [UsersController::class, 'show'])->name('show');
            Route::get('/desabilitar/{id}', [UsersController::class, 'destroy'])->name('destroy');
            Route::get('/editar/{id}', [UsersController::class, 'edit'])->name('edit');
            Route::put('/editar/{id}', [UsersController::class, 'update'])->name('update');
            Route::get('/minha-conta', [UsersController::class, 'account'])->name('account');
            Route::put('/minha-conta', [UsersController::class, 'accountUp'])->name('accountUp');
            Route::get('/barra-lateral', [UsersController::class, 'aside'])->name('aside');
            Route::get('/aniversariantes', [UsersController::class, 'birthdays'])->name('birthdays');
            Route::get('/aprovar/{id}/{status}', [UsersController::class, 'aprove'])->name('aprove');
            Route::get('/ranking', [UsersController::class, 'ranking'])->name('ranking');
            Route::get('/{id?}', [UsersController::class, 'index'])->name('index');
        });
    });
    
    // USERS
    Route::prefix('pontos')->group(function () {
        Route::name('points.')->group(function () {
            Route::get('/', [PointsController::class, 'index'])->name('index');
            Route::post('/adicionar', [PointsController::class, 'store'])->name('store')->middleware('admin');
            Route::get('/pontuacao', [PointsController::class, 'table'])->name('table');
        });
    });
    
    // USERS
    Route::prefix('premios')->middleware('admin')->group(function () {
        Route::name('awards.')->group(function () {
            Route::get('/', [AwardsController::class, 'index'])->name('index');
            Route::get('/adicionar', [AwardsController::class, 'create'])->name('create');
            Route::post('/adicionar', [AwardsController::class, 'store'])->name('store');
            Route::get('/visualizando/{id}', [AwardsController::class, 'show'])->name('show');
            Route::get('/desabilitar/{id}', [AwardsController::class, 'destroy'])->name('destroy');
            Route::get('/editar/{id}', [AwardsController::class, 'edit'])->name('edit');
            Route::put('/editar/{id}', [AwardsController::class, 'update'])->name('update');
        });
    });
    
    // USERS
    Route::prefix('envio-de-premios')->middleware('admin')->group(function () {
        Route::name('send.awards.')->group(function () {
            Route::get('/', [SendAwardsController::class, 'index'])->name('index');
            Route::get('/adicionar', [SendAwardsController::class, 'create'])->name('create');
            Route::post('/adicionar', [SendAwardsController::class, 'store'])->name('store');
            Route::get('/visualizando/{id}', [SendAwardsController::class, 'show'])->name('show');
            Route::get('/desabilitar/{id}/{status}', [SendAwardsController::class, 'destroy'])->name('destroy');
            Route::get('/editar/{id}', [SendAwardsController::class, 'edit'])->name('edit');
            Route::put('/editar/{id}', [SendAwardsController::class, 'update'])->name('update');
            Route::get('/email', [SendAwardsController::class, 'mail'])->name('email');
        });
    });
    
    Route::get('/solicitar', [AwardsController::class, 'results'])->name('awards.results');
    Route::get('/solicitar/{id}', [SendAwardsController::class, 'request'])->name('send.awards.request');

});

Route::get('/teste-email/{email?}', [SendAwardsController::class, 'mail'])->name('email');


require __DIR__.'/auth.php';

app/Models/Award.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Relations\HasOne;

class Award extends Model
{
    use HasFactory;
    /**
     * The attributes that are mass assignable.
     *
     * @var array<int, string>
     */
    protected $fillable = [
        'name',
        'description',
        'points',
        'valid',
        'created_by',
        'status',
    ];
}

app/Http/Controllers/AwardsController.php
<?php

namespace App\Http\Controllers;

use App\Mail\Notifications;
use App\Models\Award;
use App\Models\User;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Log;
use Illuminate\Support\Facades\Mail;
use Illuminate\Support\Facades\Storage;

class AwardsController extends Controller
{
    protected $request;
    private $repository;
    
    public function __construct(Request $request, Award $content)
    {
        
        $this->request = $request;
        $this->repository = $content;

    }

    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {

        // GET ALL DATA
        $contents = Award::orderBy('name', 'ASC')->get();

        // RETURN VIEW WITH DATA
        return view('pages.awards.index', [
            'contents' => $contents,
        ]);

    }

    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function results()
    {

        // GET ALL DATA
        $contents = Award::where("valid", '>=', date('Y-m-d'))->orWhere('valid', null)->orderBy('name', 'ASC')->get();

        // RETURN VIEW WITH DATA
        return view('pages.awards.results', [
            'contents' => $contents,
        ]);

    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        // GET ALL DATA
        return view('pages.awards.create');
    }

    // DEFINE FOLDER ROUTE
    public function folderRoute()
    {
        return "public/premios/";
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {

        // GET FORM DATA
        $data = $request->all();

        // CREATED BY
        $data['created_by'] = Auth::id();
        $data['valid'] = $data['valid'] != null ? convertDateFormat($data['valid']) : null;

        // SEND DATA
        $insert = $this->repository->create($data);

        // CHECK IF THE USER SENT AN IMAGE AND VALIDATE
        storeImage($this->folderRoute(), $request->image, $insert->id);

        if($insert){

            // PARAMETERS FROM EMAIL
            $parameters = [
                'fromName' => 'Dalmóbile',
                'fromEmail' => 'smtp@dreamake.com.br',
                'subject' => 'Novo prêmio adicionado a plataforma!',
            ];

            // CREATE URL FOR RESET PASSWORD
            $btn = 'ACESSAR MINHA CONTA';
            $url = route('dashboard');

            // MESSAGE
            $message = 'Acabamos de adicionar ' . $request->name . ', veja em sua conta quantos pontos você possui, se tiver pontos suficiente e desejar, restage o prêmio!';
            
            // GET USERS
            $users = User::where('status', 1)->get();

            foreach($users as $user){
                // EMAIL
                $email = $user->email;

                // CONTENT OF EMAIL
                $data = [
                    'name' => $user->name,
                    'email' => $email,
                    'url' => $url,
                    'btn' => $btn,
                    'message' => $message,
                ];
                
                try {
                    Mail::to($email)->send(new Notifications($data, $parameters['subject'], $parameters['fromEmail'], $parameters['fromName']));
                } catch (\Exception $e) {
                    // Captura e registra a exceção, permitindo que o loop continue
                    // Isso NÃO é recomendado na maioria das situações
                    Log::error('Erro ao enviar email para ' . $email . ': ' . $e->getMessage());
                }
            }
        }

        // REDIRECT AND MESSAGES
        return redirect()
            ->route('awards.index')
            ->with('message', 'Prêmio criado com sucesso.');
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        // VERIFY IF EXISTS
        if(!$content = Award::find($id)){
            return redirect()->back();
        }

        // GENERATES DISPLAY WITH DATA
        return view('pages.awards.edit')->with([
            'content' => $content,  
        ]);
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {

        // GET FORM DATA
        $data = $request->all();     
        
        // CHECK IF THE USER SENT AN IMAGE AND VALIDATE
        storeImage($this->folderRoute(), $request->image, $id);

        // UPDATE BY
        $data['updated_by'] = Auth::id();
        $data['valid'] = $data['valid'] != null ? convertDateFormat($data['valid']) : null;

        // STORING NEW DATA
        $content = Award::find($id);
        $content->update($data);

        // REDIRECT AND MESSAGES
        return redirect()
        ->route('awards.index')
        ->with('message', 'Prêmio atualizado com sucesso.');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        
        // GET DATA
        $content = Award::find($id);

        // STORING NEW DATA
        if($content->status == 1){
            Award::where('id', $id)->update(['status' => 0]);
            $message = 'desabilitado';
        } else {
            Award::where('id', $id)->update(['status' => 1]);
            $message = 'habilitado';
        }
        

        // REDIRECT AND MESSAGES
        return redirect()
        ->route('awards.index')
        ->with('message', 'Prêmio <b>'. $content->name . '</b> '. $message .' com sucesso.');

    }

}

resources/views/pages/awards/create.blade.php
@extends('layouts.app')

@section('page-title', 'Adicionar Prêmio')

@section('content')
<!--begin::Content-->
<div id="kt_app_content" class="app-content flex-column-fluid pt-10">
    <!--begin::Content container-->
    <div id="kt_app_content_container" class="app-container container-fluid">
        <!--begin::Container-->
        <div id="kt_content_container" class="container-fluid">
            <!--begin::Row-->
            <div class="row g-5 g-xl-8">
                <div class="col-xl-12 m-0 p-0">
                    <div class="card">
                        <div class="card-body fs-6 p-10 text-gray-700">
                            <form action="{{ route('awards.store') }}" method="POST" enctype="multipart/form-data">
                                @csrf
                                <div class="row gx-10 mb-5">
                                    @include('pages._forms.awards')
                                    <div class="d-flex justify-content-end mt-5">
                                        <input type="submit" class="btn btn-primary btn-active-danger mb-3" value="Cadastrar"></input>
                                    </div>
                                </div>
                            </form>
                        </div>
                    </div>
                </div>
            </div>
            <!--end::Row-->
        </div>
        <!--end::Container-->
    </div>
</div>
<!--end::Content-->
@endsection

resources/views/pages/awards/edit.blade.php
@extends('layouts.app')

@section('page-title', 'Editar Prêmio')

@section('content')
<!--begin::Content-->
<div id="kt_app_content" class="app-content flex-column-fluid pt-10">
    <!--begin::Content container-->
    <div id="kt_app_content_container" class="app-container container-fluid">
        <!--begin::Container-->
        <div id="kt_content_container" class="container-fluid">
            <!--begin::Row-->
            <div class="row g-5 g-xl-8">
                <div class="col-xl-12 m-0 p-0">
                    <div class="card">
                        <div class="card-body fs-6 p-10 text-gray-700">
                            <form action="{{ route('awards.update', $content->id) }}" method="POST" enctype="multipart/form-data">
                                @method('PUT')
                                @csrf
                                <div class="row gx-10 mb-5">
                                    @include('pages._forms.awards')
                                    <div class="d-flex justify-content-end mt-5">
                                        <input type="submit" class="btn btn-primary btn-active-danger text-light mb-3" value="Atualizar"></input>
                                    </div>
                                </div>
                            </form>
                        </div>
                    </div>
                </div>
            </div>
            <!--end::Row-->
        </div>
        <!--end::Container-->
    </div>
</div>
<!--end::Content-->
@endsection


@section('custom-footer')

<script>

    $('.short-name').keyup(function(){
        var input = $(this);
        var words = input.val().split(' ');
        if (words.length > 2) {
            input.val(words.slice(0, 2).join(' '));
        }
        $('.input-email').val(input.val().normalize('NFD').replace(/[\u0300-\u036f]/g, "").replace(/\s+/g, ".").toLowerCase() + '@dalmobilesjc.com.br');
    });

    $('#auto-pass').click(function(){
        var chars = "0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJLMNOPQRSTUVWXYZ!@#$%^&*()+?><:{}[]";
        var passwordLength = 16;
        var password = "";

        for (var i = 0; i < passwordLength; i++) {
            var randomNumber = Math.floor(Math.random() * chars.length);
            password += chars.substring(randomNumber, randomNumber + 1);
        }
        console.log(password);
        $('[name="password"]').val(password);
    });

</script>

@endsection

resources/views/pages/awards/index.blade.php
@extends('layouts.app')

@section('page-title', 'Prêmios')

@section('url-toolbar', route('awards.create'))

@section('text-toolbar', 'Adicionar Prêmio')

@section('content')
<!--begin::Content-->
<div id="kt_app_content" class="app-content flex-column-fluid">
    <!--begin::Content container-->
    <div id="kt_app_content_container" class="app-container container-fluid">
        <!--begin::Container-->
        <div id="kt_content_container" class="container-fluid">
            <!--begin::Row-->
            <div class="row g-5 g-xl-8">
                <div class="col-xl-12 p-0">
                    <div class="card">
                        <div class="card-body fs-6 p-10 text-gray-700">
                            <table id="datatables" class="table table-striped table-row-bordered gy-5 gs-7 border rounded">
                                <thead>
                                    <tr class="fw-bold fs-6 text-gray-800 px-7">
                                        <th class="w-50px">ID</th>
                                        <th>Nome</th>
                                        <th>Pontos</th>
                                        <th>Válido</th>
                                        <th>Status</th>
                                        <th>Ações</th>
                                    </tr>
                                </thead>
                                <tbody class="table-pd">
                                    @foreach ($contents as $content)
                                    <tr>
                                        <td>
                                            <span class="text-gray-700">{{ $content->id }}</span>
                                        </td>
                                        <td style="min-width: 25%; padding: 11px;">
                                            <div class="d-flex align-items-center">
                                                <div class="symbol symbol-30px me-5">
                                                    <img src="{{ searchImage('premios', $content->id) }}" class="rounded object-fit-cover" alt="">
                                                </div>
                                                <div class="d-flex justify-content-start">
                                                    <a href="{{ route('awards.edit', $content->id) }}" class="text-gray-700 fw-bold text-hover-primary fs-6">{{ Str::limit($content->name, 35) }}</a>
                                                </div>
                                            </div>
                                        </td>
                                        <td class="text-gray-700">
                                            <span class="badge badge-light-danger">{{ $content->points }}</span>
                                        </td>
                                        <td class="text-gray-700">
                                            <div class="d-flex align-items-center">
                                                @if($content->valid != null)
                                                <span class="badge badge-light-primary">{{ date('d/m/Y', strtotime($content->valid)) }}</span>
                                                @else
                                                <span class="badge badge-light">Sem validade</span>
                                                @endif
                                            </div>
                                        </td>
                                        <td class="text-gray-700">
                                            <div class="d-flex align-items-center">
                                                @if($content->status == 1)
                                                <span class="badge badge-light-primary">Ativo</span>
                                                @else
                                                <span class="badge badge-light-danger">Inativo</span>
                                                @endif
                                            </div>
                                        </td>
                                        <td>
                                            <div class="d-flex align-items-center icons-edit">
                                                <a href="{{ route('awards.edit', $content->id) }}">
                                                    <i class="fas fa-edit px-1" title="Editar"></i>
                                                </a>
                                                @if($content->status == 1)
                                                <a href="{{ route('awards.destroy', $content->id) }}">
                                                    <i class="fas fa-times-circle px-1" title="Desativar"></i>
                                                </a>
                                                @else
                                                <a href="{{ route('awards.destroy', $content->id) }}">
                                                    <i class="fas fa-redo px-1" title="Reativar"></i>
                                                </a>
                                                @endif
                                            </div>
                                        </td>
                                    </tr> 
                                    @endforeach
                                </tbody>
                            </table>
                        </div>
                    </div>
                </div>
            </div>
            <!--end::Row-->
        </div>
        <!--end::Container-->
    </div>
    <!--end::Post-->
</div>
<!--end::Content-->
@endsection

resources/views/pages/awards/results.blade.php
@extends('layouts.app')

@section('page-title', 'Prêmios')

@section('url-toolbar', route('dashboard'))

@section('text-toolbar', 'Solicitações')

@section('content')
<!--begin::Content-->
<div id="kt_app_content" class="app-content flex-column-fluid">
    <!--begin::Content container-->
    <div id="kt_app_content_container" class="app-container container-fluid">
        <!--begin::Container-->
        <div id="kt_content_container" class="container-fluid">
            <!--begin::Row-->
            <div class="row g-5 g-xl-8">
                @foreach ($contents as $content)
                <div class="col-md-3">
                    <div class="card h-100">
                        <div class="card-body p-2">
                            <img src="{{ searchImage('premios', $content->id, true, true) }}" class="rounded object-fit-cover w-100 h-150px" alt="">
                            <p class="text-center mb-0 mt-4 fs-4 text-gray-800 fw-bold">{{ $content->name }}</p>
                            <p class="text-center mt-2 mb-0">
                                <span class="badge badge-danger">Pontos: {{ $content->points }}</span>
                                @if($content->valid != null)
                                <span class="badge badge-primary">Válido até: {{ date('d/m/Y', strtotime($content->valid)) }}</span>
                                @endif
                            </p>
                        </div>
                        <div class="card-footer p-4">
                            @if (Auth::user()->points->sum('points') >= $content->points)
                            <a href="{{ route('send.awards.request', $content->id) }}" class="btn btn-sm btn-primary w-100 fs-6">Resgatar Prêmio</a>
                            @else
                            <span class="btn btn-sm btn-light cursor-default w-100 fs-6">Ganhe mais pontos</span>
                            @endif
                        </div>
                    </div>
                </div>
                @endforeach
            </div>
            <!--end::Row-->
        </div>
        <!--end::Container-->
    </div>
    <!--end::Post-->
</div>
<!--end::Content-->
@endsection